## llvm-toolchain-13 13.0.0

=== debian/changelog ===
llvm-toolchain-13 (1:13.0.0-6) unstable; urgency=medium

  * Remove omp-device-info from LLVMExports.cmake (Closes: #996551)
  * Fix a atomic issue. Thanks to YunQiang Su for the patch
    Partial fix for #995827
  * Bring back the llvm manpages (Closes: #995684)
    Were generated at the wrong place

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 15 Oct 2021 10:45:30 +0200

llvm-toolchain-13 (1:13.0.0-5) unstable; urgency=medium

  *  Restrict the dependency on libunwind-13-dev from Package: libc++-13-dev
     on amd64 arm64 armhf i386 mips64el ppc64el ppc64 riscv64
     (Closes: #996462)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 14 Oct 2021 12:33:15 +0200

llvm-toolchain-13 (1:13.0.0-4) unstable; urgency=medium

  * Instead of using llvm-* to install binaries in llvm-X.Y
    list all the binaries one by one.
    It will prevent "llvm-omp-device-info" to be installed in
    llvm-X.Y which caused an explicit dependency on libomp
    which caused llvm-X.Y to be NOT coinstallable anymore
  * Move llvm-omp-device-info-X.Y from llvm-X to libompX-dev
    Fixes upstream #52162

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 13 Oct 2021 13:29:51 +0200

llvm-toolchain-13 (1:13.0.0-3) unstable; urgency=medium

  * libc++-13-dev should depends on libunwind-13-dev
    (Closes: #995810)
  * Disable a tsan and two lldb tests on i386

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 06 Oct 2021 12:52:10 +0200

llvm-toolchain-13 (1:13.0.0-2) unstable; urgency=medium

  * Fix the libclang detection in cmake
    (Closes: #994827)
  * Adjust the testsuite after various changes
    (rpass, libclang, polly lib, etc)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 03 Oct 2021 22:38:18 +0200

llvm-toolchain-13 (1:13.0.0-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 01 Oct 2021 09:08:08 +0200

llvm-toolchain-12 (1:12.0.1-10) UNRELEASED; urgency=medium

  * If parallel is not set in DEB_BUILD_OPTIONS, use nproc
  * Add source-is-missing llvm/test/* / lldb/test/* / lld/test/*
    to the source override
  * Remove old override 'outdated-autotools-helper-file'

  [ John Paul Adrian Glaubitz ]
  * Disable libunwind on sparc, sparc64 and x32

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 02 Oct 2021 10:50:27 +0200

llvm-toolchain-11 (1:11.1.0-3) unstable; urgency=medium

  * Add two patches from ubuntu to fix lto and gcc-11 build failures
  * Use minimum version for cmake-test
  * Don't require libclang-11-dev on cmake-test
  * Add new llvm-11-linker-tools (from Ubuntu)
  * Merge new fixes from branch=9
  * clang-11: Drop Recommends: libomp-11-dev

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Sep 2021 15:50:46 +0200

llvm-toolchain-11 (1:11.1.0-2) unstable; urgency=medium

  * Adjust the cmake test to unbreak autopkgtest

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 26 Sep 2021 22:02:43 +0200

llvm-toolchain-11 (1:11.1.0-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * Upload to unstable
  * bump autopkgtest cmake version (Closes: #994501)
    Thanks to Timo Röhling for the patch

  [ Gianfranco Costamagna ]
  * Cherry-pick upstream commit to fix a libgl1-mesa-dri texture failure.
    (Closes: #989545)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 24 Sep 2021 12:54:55 +0200

llvm-toolchain-9 (1:9.0.1-19) unstable; urgency=medium

  * Add two patches from ubuntu to fix lto and gcc-11 build failures

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Sep 2021 15:39:19 +0200

llvm-toolchain-9 (1:9.0.1-18) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Cherry-pick nmu again. (version 16.1)
  * bump minimum cmake version on qualify-clang.sh too
  * simplify cmake test without minor version
  [ Andreas Beckmann <anbe@debian.org> ]
  * clang-9: Drop Recommends: libomp-9-dev which is not co-installable with
    libomp-11-dev (and libomp-dev) for smoother upgrades of libomp-dev from
    buster to bullseye.  (Closes: #990452)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Sep 2021 15:02:13 +0200

llvm-toolchain-9 (1:9.0.1-17) unstable; urgency=medium

  * Remove an old breaks/replaces for 9 which was causing
    some issues on Debian buster. Thanks to Julien Wajsberg
    for the bug report
  * bump autopkgtest cmake version (Closes: #994501)
    Thanks to Timo Röhling for the patch
  * cherry pick 68d5235cb58f988c71b403334cd9482d663841ab to build
    with newer version of the kernel

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 25 Sep 2021 16:00:36 +0200

llvm-toolchain-9 (1:9.0.1-16) unstable; urgency=medium

  * Only enable libomp-9-doc on supported archs

  [ Adrian Bunk ]
  * Fix the fuzzer build on i386.

  [ Sylvestre Ledru ]
  * Ignore some tests on i386 to get autopkgtest fixed (Closes: #972334)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 07 Nov 2020 15:53:51 +0100
