## llvm-toolchain-13 13.0.1~+rc1

=== debian/changelog ===
llvm-toolchain-13 (1:13.0.1~+rc1-1~exp4) experimental; urgency=medium

  * Fix the cmake file with the mlir introducing

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 06 Jan 2022 14:30:59 +0100

llvm-toolchain-13 (1:13.0.1~+rc1-1~exp3) experimental; urgency=medium

  * Build and ship MLIR as 3 new packages (libmlir-13-dev, libmlir-13
    and mlir-13-tools)
  * Install bfd plugins in
    /usr/lib/bfd-plugins/LLVMgold-@LLVM_VERSION@.so

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 31 Dec 2021 12:22:38 +0100

llvm-toolchain-13 (1:13.0.1~+rc1-1~exp2) experimental; urgency=medium

  * Bring back the dependency clang => llvm-13-linker-tools
  * Unbreak llvm-toolchain-13 on buster.
    -fuse-ld=gold wasn't passed to compiler-rt. it was using bfd.
    And binutils shipping in buster has a bug preventing this to work:
    https://github.com/llvm/llvm-project/issues/42339
  * Remove AVR from LLVM_EXPERIMENTAL_TARGETS_TO_BUILD. stable since 11
    https://releases.llvm.org/11.0.0/docs/ReleaseNotes.html#changes-to-the-avr-target
  * Use the version suffix when calling wasm-ld => wasm-ld-13
    https://bugzilla.mozilla.org/show_bug.cgi?id=1747145
  * Fix run-clang-tidy symlink. it moved from /usr/lib/llvm-13/share/clang/run-clang-tidy
    to /usr/lib/llvm-13/bin/run-clang-tidy
    (Closes: #1001748)
  * Install LLVMgold in usr/lib/bfd-plugins to help various tools to understand the
    format (Closes: #919020)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 16 Dec 2021 14:28:09 +0100

llvm-toolchain-13 (1:13.0.1~+rc1-1~exp1) experimental; urgency=medium

  * New testing release
  * Use parallel + -4 for the xz tarballs compression to make it faster
  * Add manpages for git-clang-format & run-clang-tidy
  * Add back -DLLVM_VERSION_SUFFIX=. Useless for 13 but necessary for snapshot
    Otherwise, it adds "git" to the libs

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 11 Nov 2021 22:45:25 +0100

llvm-toolchain-13 (1:13.0.0-9) unstable; urgency=medium

  * Upload to unstable (all green on exp)
  * Fix an autopkgtest test (Closes: #997902)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 08 Nov 2021 14:09:25 +0100

llvm-toolchain-13 (1:13.0.0-9~exp2) experimental; urgency=medium

  * patch compiler-rt build to add option to disable scudo standalone allocator
    as it is not always supported by all debian baseline arch profiles
  * add COMPILER_RT_BUILD_SCUDO_STANDALONE=OFF to armel build in debian/rules
    since the baseline armv5t arch profile is not supported

 -- Erik Maciejewski <mr.emacski@gmail.com>  Fri, 05 Nov 2021 16:38:43 -0700

llvm-toolchain-13 (1:13.0.0-9~exp1) experimental; urgency=medium

  * Merge migration to 2stage runtimes build 12 => 13
  * Adjust openmp runtime quilt patches from branch 12 for changes in upstream
    (llvmorg-13.0.0) sources

 -- Erik Maciejewski <mr.emacski@gmail.com>  Wed, 03 Nov 2021 20:03:56 -0700

llvm-toolchain-13 (1:13.0.0-8) unstable; urgency=medium

  * Disable lldb on mipsel and mips64el as it isn't supported
    See https://reviews.llvm.org/D102872
    (Closes: #997011)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 23 Oct 2021 10:33:56 +0200

llvm-toolchain-13 (1:13.0.0-7) unstable; urgency=medium

  * Remove omp-device-info from LLVMExports.cmake (Closes: #996551)
    For real this time
  * Fix the link issue (hopefully on all archs) (Closes: #995827)
    customs LDFLAGS were not passed to the stage2
  * Trim trailing whitespace.
  * Update watch file format version to 4.
  * Update to compat 11.
    oldstable has 12
    bionic has 11

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 20 Oct 2021 07:36:28 +0200

llvm-toolchain-12 (1:12.0.1-16) unstable; urgency=medium

  [ Erik Maciejewski ]
  * use make variables populated by /usr/share/dpkg/buildflags.mk and remove
    _EXTRA suffix from STAGE_1_ and STAGE_2_ flag vars to improve clarity and
    readability for the multi-stage setup in debian/rules
  * remove some redundant cmake options (options with the same value as their
    default) from, and move PYTHON_EXECUTABLE cmake option to, the cmake
    configure command in debian/rules
  * re-disable fixfilepath in dpkg-buildflags in favor of using the more llvm
    aware implementation provided by the llvm-project by setting
    LLVM_USE_RELATIVE_PATHS_IN_FILES=ON in both stages of the toolchain
    build in debian/rules

  [ Sylvestre Ledru ]
  * autopkgtest/integration-test-suite-test: restrict to arm64/amd64 for now

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 28 Oct 2021 16:45:49 +0200

llvm-toolchain-12 (1:12.0.1-15) unstable; urgency=medium

  * Disable lldb on mipsel and mips64el as it isn't supported
    See https://reviews.llvm.org/D102872
    (Closes: #997011)

  [ Erik Maciejewski ]
  * disable compiler-rt builtins for unsupported arch s390x in debian/rules
  * set arm toolchain arch profiles explicitly to debian baselines in
    debian/rules as the target host triples alone are ambiguous and compiler
    defaults and debian baselines may not align
  * add arch specific config for powerpc to debian/rules and set host target
    triple and compiler-rt config to force correct arch profile for builtins
  * set LIBCXX_USE_COMPILER_RT to OFF in debian/rules to disable builtins when
    libunwind is not enabled since the unwind implementation with gnu builtins
    will then be required

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 23 Oct 2021 10:33:56 +0200

llvm-toolchain-12 (1:12.0.1-14) unstable; urgency=medium

  * fix build flag inconsistencies (potentially causing build failures) by
    utilizing dpkg-buildflags for defaults where appropriate and making sure all
    flags intended for a given stage are also applied to the stage's builtins
    and runtimes builds
  * re-enable fixfilepath for use with dpkg-buildflags in debian/rules as it has
    been supported since clang-10
  * establish a consistent STAGE_[stage]_ prefix naming scheme for stage

