=== debian/control ===
--- 
+++ 
@@ -4,8 +4,9 @@
 Rules-Requires-Root: no
 Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
 Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Gianfranco Costamagna <locutusofborg@debian.org>
-Build-Depends: debhelper (>= 9.0), cmake, ninja-build,
+Build-Depends: debhelper (>= 11.0), cmake, ninja-build,
     chrpath, texinfo, sharutils,
+    libelf-dev,
     libffi-dev,
     lsb-release, patchutils, diffstat, xz-utils, python3-dev,
     libedit-dev, libncurses5-dev, swig, python3-six, python3-sphinx (>= 1.3.6),
@@ -13,7 +14,7 @@
     libxml2-dev,
     libjsoncpp-dev, pkg-config,
     lcov, procps, help2man, zlib1g-dev,
-    g++-multilib [amd64 i386 kfreebsd-amd64 mips mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
+    g++-multilib [amd64 i386 kfreebsd-amd64 mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
     libjs-mathjax, python3-recommonmark,
     doxygen, gfortran,
     ocaml-nox [amd64 arm64 armhf ppc64el riscv64 s390x],
@@ -36,6 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${dep:devlibs},
  ${dep:devlibs-objc}, libclang-common-13-dev (= ${binary:Version}),
+ llvm-13-linker-tools (= ${binary:Version}),
  libclang1-13 (= ${binary:Version}), libc6-dev, binutils
 Provides: c-compiler, objc-compiler, c++-compiler
 Recommends: llvm-13-dev, python3
@@ -292,4 +294,3 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Breaks: llvm-13-dev (<< 1:13~++20210129063721), clang-13 (<< 1:13~++20210129063721)
 Replaces: llvm-13-dev (<< 1:13~++20210129063721), clang-13 (<< 1:13~++20210129063721)
-Description: Modular compiler and toolchain technologies - Plugins
